tosca_definitions_version: tosca_simple_yaml_1_2

description: Application developer enters the ACCORDION Platform portal.
             Application developer selects and enters required data on website (resource requirements, QoE
             requirements, lifecycle management instructions, Edge devices docker image).
             Application developer sends that data to the ACCORDION platform through the ACCORDION Platform
             portal.
             Application developer receives response from the ACCORDION Platform portal with deployment
             status result.


data_types:

  find:
    properties:
      LSstatus:
        type: string
      RSstatus:
        type: string
      order:
        type: integer
  deploy:
    properties:
      region:
        type: string
      LSimage:
        type: string
      RSimage:
        type: string
      order:
        type: integer
  retrieve:
    properties:
      from:
        type: string
      LSstatus:
        type: string
      RSstatus:
        type: string
      order:
        type: integer
node_types:

  AdminTool:
    derived_from: tosca.nodes.Container.Application.Docker
    properties:
      LSdockerImage:
        type: string
      RSdockerImage:
        type: string
      qoe_requiremenets:
        type: string
      lifecycle_management_instructions:
        type: string
      hardware_requirements:
        type: map
        host:
          type: map
          properties:
            num_cpus:
              type: integer
            mem_size:
              type: string
            disk_size:
              type: string
        os:
          type: map
          properties:
            architecture:
              type: string
            os_type:
              type: string
        gpu:
          type: map
          properties:
            model:
              type: string
              required: false
            dedicated:
              type: boolean
              default: true
          required: false
      actions:
        type: map
    requirements:
      - connect:
          node: ACCORDION.Cloud
          relationship: connectToCloud

  Plexus.container:
    derived_from: tosca.nodes.Container.Application.Docker
    properties:
      dockerImage:
        type: string
      region:
        type: string
      deployment_status:
        type: string


  ACCORDION.Cloud:
      derived_from: tosca.nodes.Container.Application.Docker
      properties:
        actions:
          type: map



relationship_types:
  connectToCloud:
    derived_from: tosca.relationships.Root
    valid_target_types: [ tosca.capabilities.Node ]



topology_template:
  inputs:
    image:
      type: string
      description: name of image
      required: false
    region:
      type: string
      description: geolocation of a Game Server group
      required: false
    qoe:
      type: string
      required: false
    instructions:
      type: string
      required: false
    status:
      type: string
      required: false
  node_templates:


    Portal:
      type: AdminTool
      properties:
        LSdockerImage: { get_input: image }
        RSdockerImage: {get_input: image}
        qoe_requiremenets: {get_input: qoe}
        lifecycle_management_instructions: {get_input: instructions}
        hardware_requirements:
          properties:
            host:
              properties:
                num_cpus: 1
                mem_size: 512 MB
                disk_size: 20 GB
            os:
              properties:
                architecture: x86_64
                os_type: linux
            gpu:
              properties:
                model: something
                architecture: something
        actions:
          retrieve:
            properties:
              from: Accordion
              LSstatus: {get_property: [Accordion, LSstatus]}
              RSstatus: {get_property: [Accordion, RSstatus]}
              order: 3
      requirements:
        - connect:
            node: Accordion
            relationship: connectToCloud


    Accordion:
      type: ACCORDION.Cloud
      properties:
        actions:
          deploy:
            properties:
              LSimage: { get_property: [Portal,connectToCloud,dockerImage] }
              RSimage: { get_property: [Portal,connectToCloud,dockerImage] }
              order: 1
          retrieve:
            properties:
              from: LS,RS
              LSstatus: {get_property: [LS,deployment_status]}
              RSstatus: {get_property: [RS,deployment_status]}
              order: 2

    LS:
      type: Plexus.container
      properties:
        dockerImage: { get_property: [Portal,LSdockerImage] }
        region: {get_input: region}
        deployment_status: {get_input: status}


    RS:
      type: Plexus.container
      properties:
        dockerImage: { get_property: [ Portal,RSdockerImage ] }
        region: { get_input: region }
        deployment_status: { get_input: status }


